<?php
defined('IN_MOBIQUO') or exit;
include (dirname(dirname(__FILE__))."/include/classTTSSO.php");

require_once('./global.php');
require_once(DIR . '/includes/functions_misc.php');

function sign_in_func($xmlrpc_params)
{
    global $vbulletin, $tt_config, $backup_forceoptions, $db;
    $params = php_xmlrpc_decode($xmlrpc_params);
    $InputParams = array(
		'token'       => mobiquo_encode($params[0], 'to_local'),
		'code'        => mobiquo_encode($params[1], 'to_local'),
		'email'       => mobiquo_encode($params[2], 'to_local'),
		'username'    => mobiquo_encode($params[3], 'to_local'),
		'password'	  => mobiquo_encode($params[4], 'to_local'),
		'custom_register_fields'    =>  $params[5],
	);
	$ssoHandle = new TTSSOBase(new TTSSOForum());
    $ssoHandle->signIn($InputParams);
    if(!empty($ssoHandle->result) && $ssoHandle->result)
	{
        $return_array = $ssoHandle->result;
        foreach($ssoHandle->errors as $error)
        {
            $finalError .= $error."\n";
        }
        $return_array['result_text'] = new xmlrpcval($finalError, 'base64');
        $return = new xmlrpcresp(new xmlrpcval($return_array, 'struct'));
        return $return;
	}
	else
	{
        $finalError = '';
        foreach($ssoHandle->errors as $error)
        {
            $finalError .= $error."\n";
        }

        $result = new xmlrpcval(array(
            'result'        => new xmlrpcval(false, 'boolean'),
            'result_text'   => new xmlrpcval($finalError, 'base64'),
        ), 'struct');

        return new xmlrpcresp($result);	
	}
}

class TTSSOForum implements TTSSOForumInterface
{
    function __construct(){}
    
    public function getEmailByUserInfo($userInfo)
    {
        return $userInfo['email'];
    }  

    public function getUserByEmail($email)
    {
        $user = get_user_by_NameorEmail($email);
        return $user;
    }
    public function getUserByName($username)
    {
        $user = get_user_by_NameorEmail($username);
        return $user;
    }

    // the response should be bool to indicate if the username meet the forum requirement
    public function validateUsernameHandle($username)
    {
        $user = get_user_by_NameorEmail($username);
        $username_exist = isset($user['userid']) && !empty($user['userid']);
        return $username_exist ? false : true; 
    }

    // the response should be bool to indicate if the password meet the forum requirement
    public function validatePasswordHandle($password)
    {
        if(trim($password) == '')
        {
            return false;
        }
        return true;
    }

    // create a user, $verified indicate if it need user activation
    public function createUserHandle($email, $username, $password, $verified, $custom_register_fields, $profile, &$errors)
    {
        global $vbulletin, $tt_config, $backup_forceoptions, $db;
        $_POST['email'] = mobiquo_encode($email, 'to_local');
        $_POST['username'] = mobiquo_encode($username, 'to_local');
        $_POST['password'] = mobiquo_encode($password, 'to_local');
        $_POST['password_md5'] = md5($_POST['password']);
        $_POST['agree'] = 1;

        //gavatar? vb don't support
        if(!$tt_config['sso_signin'])
        {
            $errors[] = 'Application Error : social sign in is not supported currently.';
            return false;
        }
        //formating custom fields    
        $custom_fields = $custom_register_fields;
        if(!empty($custom_fields))
        {
            foreach($custom_fields as $filed_name => $field_value)
            {
                //hv_question verify
                if(preg_match('/hv_input,.*/', $filed_name))
                {
                    $arr = explode(",", $filed_name);
                    $hv_verify['input'] = $field_value;
                    $hv_verify['hash'] = $arr[1];
                    // Human Verification, not neccessary if user is logged into facebook
                    include_once(DIR . '/includes/functions.php');
                    if (fetch_require_hvcheck('register') AND (!is_facebookenabled() OR (is_facebookenabled() AND !vB_Facebook::instance()->userIsLoggedIn())))
                    {
                        require_once(DIR . '/includes/class_humanverify.php');
                        $tt_verify =& vB_HumanVerify::fetch_library($vbulletin);
                        if (!$tt_verify->verify_token($hv_verify))
                        {
                            $errors[] = 'The answer given for the random question was incorrect.';
                            return false;
                        }
                    }
                }
                if($filed_name == "COPPA_BIRTHDAY" || $filed_name == "REQ_BIRTHDAY")
                {
                    $birthday = explode('-', $field_value);
                    $_POST['month'] = $birthday[1];
                    $_POST['year']= $birthday[0];
                    $_POST['day']= $birthday[2];
                    continue;
                }

                if(is_array($field_value))
                {
                    $orgnized_value = array();
                    foreach($field_value as $key => $value)
                    {
                        $orgnized_value[] = $key;
                    }
                    $custom_fields[$filed_name] = $orgnized_value;
                }
                else
                {
                    $custom_fields[$filed_name] = mobiquo_encode($field_value, 'to_local');
                }
                $custom_fields[$filed_name.'_set'] = 1;
            }
            $profilefields = $db->query_read_slave("
                SELECT *
                FROM " . TABLE_PREFIX . "profilefield
                WHERE editable > 0 AND required <> 0
                ORDER BY displayorder
            ");
            while ($profilefield = $db->fetch_array($profilefields))
            {
                $profilefieldname = "field$profilefield[profilefieldid]";
                if ($profilefield['type'] == 'radio' OR $profilefield['type'] == 'select')
                {
                    if(isset($custom_fields[$profilefieldname]))
                    {
                        $custom_fields[$profilefieldname] = $custom_fields[$profilefieldname][0];
                    }
                }
                if(isset($custom_fields[$profilefieldname]) && $profilefield['regex'])
                {//$profilefield['title'])
                    if (!preg_match('#' . str_replace('#', '\#', $profilefield['regex']) . '#siU', $custom_fields[$profilefieldname]))
                    {
                        $profilefield['title'] = fetch_phrase($profilefieldname . '_title', 'cprofilefield');
                        eval(standard_error(fetch_error('regexincorrect', $profilefield['title'])));
                    }
                }
                
            }
            $_POST['userfield'] = $custom_fields;
        }

        if (!$verified)
            $reg_response = register_user(true, false, $profile);
        else
            $reg_response = register_user(false, false, $profile,$verified);

        if(is_array($reg_response))
        {
            list($user_id, $result_text) = $reg_response;

            if($user_id != 0) 
            {
                // register succeed, try to add custom avatar
                if(isset($profile['avatar_url'])&& !empty($profile['avatar_url']))
                {
                    try
                    {
                        $_POST['userid'] = $user_id;
                        $_POST['avatarid'] = 0;
                        $_POST['avatarurl'] = $profile['avatar_url'];
                        $_POST['resize'] = 1;
                        $vbulletin->input->clean_array_gpc('p', array(
                            'userid'    => TYPE_UINT,
                            'avatarid'  => TYPE_INT,
                            'avatarurl' => TYPE_STR,
                            'resize'    => TYPE_BOOL,
                        ));
                            $useavatar = iif($vbulletin->GPC['avatarid'] == -1, 0, 1);

                        $userinfo = fetch_userinfo($vbulletin->GPC['userid']);

                        // init user datamanager
                        $userdata =& datamanager_init('User', $vbulletin, ERRTYPE_CP);
                        $userdata->set_existing($userinfo);

                        // custom avatar
                        $vbulletin->input->clean_gpc('f', 'upload', TYPE_FILE);
            
                        require_once(DIR . '/includes/class_upload.php');
                        require_once(DIR . '/includes/class_image.php');
            
                        $upload = new vB_Upload_Userpic($vbulletin);
            
                        $upload->data =& datamanager_init('Userpic_Avatar', $vbulletin, ERRTYPE_CP, 'userpic');
                        $upload->image =& vB_Image::fetch_library($vbulletin);
                        $upload->userinfo =& $userinfo;
            
                        cache_permissions($userinfo, false);
            
                        // user's group doesn't have permission to use custom avatars
                        if ($userinfo['permissions']['genericpermissions'] & $vbulletin->bf_ugp_genericpermissions['canuseavatar'])
                        {
                            if ($vbulletin->GPC['resize'])
                            {
                                $upload->maxwidth = $userinfo['permissions']['avatarmaxwidth'];
                                $upload->maxheight = $userinfo['permissions']['avatarmaxheight'];
                            }
                            if ($upload->process_upload($vbulletin->GPC['avatarurl']))
                            {
                                $userdata->set('avatarid', $vbulletin->GPC['avatarid']);
                                $userdata->save();
                            }
                        }
                    }
                    catch(Exception $e){}
                }
                
                $user = mobiquo_verify_id('user', $user_id, 0, 1);
                return $user;//login_user($user, true); // login if registered
            }
            else
            {
                $errors[] = $result_text;
                return false;//error_status($username_exist ? '1' : '0', $result_text);
            }
        }
        else
        {
            $result_text = (string) $reg_response;
            $errors[] = $result_text;
            return false;//error_status($username_exist ? '1' : '0', $result_text);
        }
    }

    // login to an existing user, return result as bool
    public function loginUserHandle($userInfo, $register)
    {
        return login_user($userInfo,$register);
    }
    
    // return forum api key
    public function getAPIKey()
    {
        global $vbulletin;
        return $vbulletin->options['push_key'];
    }

    // return forum url
    public function getForumUrl()
    {
        global $vbulletin;
        return $vbulletin->options['bburl'];
    }
}

function login_user($user, $new_register = false)
{
	global $vbulletin, $tt_config, $backup_forceoptions, $db;

    $username = $user['username'];
    $password = $user['password'];
    $vbulletin->userinfo = $user;
    $vbulletin->GPC['logintype'] = null;
    require_once(DIR . '/includes/functions_login.php');
    require_once(DIR . '/includes/functions_user.php');
    require_once(DIR . '/includes/functions_misc.php');

    if (true)
    {
        $return = array();
        $vbulletin->GPC['username'] =$username;
        if(strlen($password) == 32){
            $vbulletin->GPC['md5password'] = $password;
            $vbulletin->GPC['md5password_utf'] = $password;
        } else {
            $vbulletin->GPC['password'] = $password;
        }

        if ($vbulletin->GPC['username'] == '')
        {
            return_fault('You have entered an invalid username or password.');
        }


        // make sure our user info stays as whoever we were (for example, we might be logged in via cookies already)
        $original_userinfo = $vbulletin->userinfo;

        exec_unstrike_user($vbulletin->GPC['username']);

        $member_groups = preg_split("/,/", $vbulletin->userinfo['membergroupids']);

        $return_group_ids = array();
        foreach($member_groups AS $id)
        {
            if($id)
            {
                array_push($return_group_ids, new xmlrpcval($id, 'string'));
            }
        }
        array_push($return_group_ids,new xmlrpcval($vbulletin->userinfo['usergroupid'], 'string'));

        process_new_login($vbulletin->GPC['logintype'], $vbulletin->GPC['cookieuser'], $vbulletin->GPC['cssprefs']);
        $vbulletin->session->save();
        vbsetcookie('userid', $vbulletin->userinfo['userid'], false, true, true);
        vbsetcookie('password', md5($vbulletin->userinfo['password'] . COOKIE_SALT), false, true, true);
        $permissions = cache_permissions($vbulletin->userinfo);
        $pmcount = $vbulletin->db->query_first("
            SELECT COUNT(pmid) AS pmtotal
            FROM " . TABLE_PREFIX . "pm AS pm
            WHERE pm.userid = '" . $vbulletin->userinfo['userid'] . "'
        ");

        $pmcount['pmtotal'] = intval($pmcount['pmtotal']);
        $show['pmmainlink'] = ($vbulletin->options['enablepms'] AND ($vbulletin->userinfo['permissions']['pmquota'] OR $pmcount['pmtotal']));
        $show['pmtracklink'] = ($vbulletin->userinfo['permissions']['pmpermissions'] & $vbulletin->bf_ugp_pmpermissions['cantrackpm']);
        $show['pmsendlink'] = ($vbulletin->userinfo['permissions']['pmquota']);
        if (!($vbulletin->userinfo['permissions']['forumpermissions'] & $vbulletin->bf_ugp_forumpermissions['canview'])){
            if (!($vbulletin->usergroupcache["$usergroupid"]['genericoptions'] & $vbulletin->bf_ugp_genericoptions['isnotbannedgroup']))
            {
        		$reason = $vbulletin->db->query_first_slave("
        			SELECT reason, liftdate
        			FROM " . TABLE_PREFIX . "userban
        			WHERE userid = " . $vbulletin->userinfo['userid']
        		);
        
        		// Check for a date or a perm ban
        		if ($reason['liftdate'])
        		{
        			$date = vbdate($vbulletin->options['dateformat'] . ', ' . $vbulletin->options['timeformat'], $reason['liftdate']);
        		}
        		else
        		{
        			$date = $vbphrase['never'];
        		}
        
        		if (!$reason['reason'])
        		{
        			$reason['reason'] = fetch_phrase('no_reason_specified', 'error');
        		}
                $result_text = mobiquo_encode(fetch_error('nopermission_banned', $reason['reason'], $date));
            } else {
                $result_text = mobiquo_encode(fetch_phrase('mb_no_permission_access', 'error'));
            }
        }

        $fetch_userinfo_options = (
            FETCH_USERINFO_AVATAR | FETCH_USERINFO_LOCATION |
            FETCH_USERINFO_PROFILEPIC | FETCH_USERINFO_SIGPIC |
            FETCH_USERINFO_USERCSS | FETCH_USERINFO_ISFRIEND
        );
        $mobiquo_userinfo = mobiquo_verify_id('user', $vbulletin->userinfo['userid'], 0, 1, $fetch_userinfo_options);

        if ($vbulletin->userinfo['userid'] AND $vbulletin->userinfo['permissions']['passwordexpires'])
        {
            $passworddaysold = floor((TIMENOW - $mobiquo_userinfo['passworddate']) / 86400);

            if ($passworddaysold >= $vbulletin->userinfo['permissions']['passwordexpires'])
            {
                $result_text = "Your password is ".$passworddaysold." days old, and has therefore expired.";
            }
        }

        if (isset($decode_params[2]) && $decode_params[2])
        {
            return new xmlrpcresp(new xmlrpcval(array(
                'result'        => new xmlrpcval(true, 'boolean'),
                'result_text'   => new xmlrpcval($result_text, 'base64'),
            ), 'struct'));
        }

        require_once(DIR . "/vb/legacy/currentuser.php");
        $current_user = new vB_Legacy_CurrentUser();
        $can_search = $current_user->hasPermission('forumpermissions', 'cansearch') && $vbulletin->options['enablesearches'];

        $max_png_size = $vbulletin->userinfo['attachmentpermissions']['png']['permissions'] ? $vbulletin->userinfo['attachmentpermissions']['png']['size'] : 0;
        $max_jpg_size = $vbulletin->userinfo['attachmentpermissions']['jpeg']['permissions'] ? $vbulletin->userinfo['attachmentpermissions']['jpeg']['size'] : 0;
        if(empty($max_jpg_size)) $max_jpg_size = $vbulletin->userinfo['attachmentpermissions']['jpg']['permissions'] ? $vbulletin->userinfo['attachmentpermissions']['jpg']['size'] : 0;
        $max_attachment = $vbulletin->options['attachlimit'] ? $vbulletin->options['attachlimit'] : 100;
        $can_whosonline = $vbulletin->options['WOLenable'] && $permissions['wolpermissions'] & $vbulletin->bf_ugp_wolpermissions['canwhosonline'];
        $can_upload_avatar = $permissions['genericpermissions'] & $vbulletin->bf_ugp_genericpermissions['canuseavatar'];
        $push_status = array();

        //fake push status
        $push_status = array();
        $supported_types = array(
            'pm'       => 'pm',
            'subscribe'=> 'sub',
            'liked'    => 'like',
            'quote'    => 'quote',
            'newtopic' => 'newtopic',
            'tag'      => 'tag',
        );
        foreach($supported_types as $support_type)
            $push_status[] = new xmlrpcval(array(
                'name'  => new xmlrpcval($support_type, 'string'),
                'value' => new xmlrpcval(true, 'boolean')
            ), 'struct');
        $ignore_users = get_ignore_ids($vbulletin->userinfo['userid']);
        if(!empty($ignore_users))
            $ignore_user_ids = implode(',', $ignore_users);

        //force user to read a thread mod 
        if(isset($backup_forceoptions) && !empty($backup_forceoptions))
        {
            $vbulletin->options['forcereadthread_disable_this_script'] = $backup_forceoptions == 'TAPATALK' ? '' : $backup_forceoptions;
            if (!($vbulletin->options['forcereadthread_disable_file'] != '' && in_array(substr($_SERVER['PHP_SELF'], (strrpos($_SERVER['PHP_SELF'], '/') + 1)), explode("\r\n", $vbulletin->options['forcereadthread_disable_file']))) && !($vbulletin->options['forcereadthread_disable_this_script'] != '' && in_array(THIS_SCRIPT, explode("\r\n", $vbulletin->options['forcereadthread_disable_this_script']))))
            {
                $where_usergroups[] = "force_read_usergroups = ''";
            
                $force_usergroupids = fetch_membergroupids_array($vbulletin->userinfo);
            
                foreach ($force_usergroupids AS $force_usergroupid)
                {
                    $where_usergroups[] = "force_read_usergroups LIKE '%-$force_usergroupid-%'";
                }
            
                $where_forums[] = "force_read_forums = ''";
            
                if ($vbulletin->userinfo['userid'] != 0)
                {
                    $force_thread = $db->query_first("
                        SELECT *
                        FROM " . TABLE_PREFIX . "thread AS thread
                        LEFT JOIN " . TABLE_PREFIX . "force_read_users AS force_read_users ON (thread.threadid = force_read_users.force_read_threadid AND force_read_users.force_read_userid = '".$vbulletin->userinfo['userid']."')
                        WHERE thread.force_read = '1' AND (thread.force_read_expire_date = '0' OR thread.force_read_expire_date > '".TIMENOW."') AND (". implode(' OR ', $where_usergroups) .") AND (". implode(' OR ', $where_forums) .") AND force_read_users.force_read_userid IS NULL
                        ORDER BY force_read_order ASC
                    ");
                    if ($force_thread)
                    {
                        $force_thread_active = $db->query_first("
                            SELECT *
                            FROM " . TABLE_PREFIX . "thread AS thread
                            WHERE force_read = '1' AND threadid = '$force_thread[threadid]'
                        ");
                        if ($force_thread_active)
                        {
                            $force_forumperms = fetch_permissions($force_thread['forumid']);
                            if (($force_forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) && ($force_forumperms & $vbulletin->bf_ugp_forumpermissions['canviewthreads']))
                            {
                                $force_already = $db->query_first("
                                    SELECT *
                                    FROM " . TABLE_PREFIX . "force_read_users AS force_read_users
                                    WHERE force_read_userid = '".$vbulletin->userinfo['userid']."' AND force_read_threadid = '$force_thread[threadid]'
                                ");

                                if (!($force_already))
                                {
                                    $db->query_write("
                                        INSERT INTO " . TABLE_PREFIX . "force_read_users
                                            (force_read_userid, force_read_threadid)
                                        VALUES
                                            ('".$vbulletin->userinfo['userid']."', '$force_thread[threadid]')
                                    ");
                                }
                                $force_thread_id = $force_thread['threadid'];
                            }
                        }

                    }
                }
            }
        }
        // $user_type = get_usertype_by_name(mobiquo_encode($vbulletin->userinfo['username']));
        $user_type = get_usertype_by_id($vbulletin->userinfo['userid']);
        $return_array = array(
            'result'            => new xmlrpcval(true, 'boolean'),
            'usergroup_id'      => new xmlrpcval($return_group_ids, 'array'),
            'register'          => new xmlrpcval($new_register, 'boolean'),
            'user_id'           => new xmlrpcval($vbulletin->userinfo['userid'], 'string'),
            'login_name'        => new xmlrpcval(mobiquo_encode($vbulletin->userinfo['username']), 'base64'),
            'display_thread_id' => new xmlrpcval(empty($force_thread_id)? '' : $force_thread_id ,'string'),
            'username'          => new xmlrpcval(mobiquo_encode($vbulletin->userinfo['username']), 'base64'),
            'email'             => new xmlrpcval(mobiquo_encode($mobiquo_userinfo['email']), 'base64'),
            'user_type'          => new xmlrpcval($user_type, 'base64'),
            'icon_url'          => new xmlrpcval(mobiquo_get_user_icon($vbulletin->userinfo['userid']), 'string'),
            'ignored_uids'      => new xmlrpcval($ignore_user_ids, 'string'),
            'post_count'        => new xmlrpcval($mobiquo_userinfo['posts'], 'int'),
            'max_attachment'    => new xmlrpcval($max_attachment, 'int'),
            'max_png_size'      => new xmlrpcval(intval($max_png_size), 'int'),
            'max_jpg_size'      => new xmlrpcval(intval($max_jpg_size), 'int'),
            'can_pm'            => new xmlrpcval($show['pmmainlink'], 'boolean'),
            'can_send_pm'       => new xmlrpcval($show['pmmainlink'] && $show['pmsendlink'], 'boolean'),
            'can_moderate'      => new xmlrpcval(can_moderate(), 'boolean'),
            'can_search'        => new xmlrpcval($can_search, 'boolean'),
            'can_whosonline'    => new xmlrpcval($can_whosonline, 'boolean'),
            'can_upload_avatar' => new xmlrpcval($can_upload_avatar, 'boolean'),
        );
        if($user_type != 'admin' && $user_type != 'mod')
        {
            $return_array['post_countdown'] =  new xmlrpcval($vbulletin->options['floodchecktime'], 'int');
        }
        if(isset($push_status) && !empty($push_status))
            $return_array['push_type'] =  new xmlrpcval($push_status, 'array');
        
        update_push();

        $return = $return_array;
    }
    else
    {
        return_fault('You have entered an invalid username or password.');
    }

    return $return;
}


function getStarndardNameByTableKey($key)
{
    $starndard_key_map = array(
        'conv'     => 'conv',
        'pm'       => 'pm',
        'subscribe'=> 'sub',
        'liked'    => 'like',
        'quote'    => 'quote',
        'newtopic' => 'newtopic',
        'tag'      => 'tag',
//        'announcement'      => 'ann',
    );
    return isset($starndard_key_map[$key])? $starndard_key_map[$key]: '';
}